# This file was auto-generated by Fern from our API Definition.

from ....core.unchecked_base_model import UncheckedBaseModel
import typing
import datetime as dt
import pydantic
from .email_address_email_address_type import EmailAddressEmailAddressType
from ....core.pydantic_utilities import IS_PYDANTIC_V2


class EmailAddress(UncheckedBaseModel):
    """
    # The EmailAddress Object
    ### Description
    The `EmailAddress` object is used to represent a candidate's email address.
    ### Usage Example
    Fetch from the `GET Candidate` endpoint and view their email addresses.
    """

    created_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The datetime that this object was created by Merge.
    """

    modified_at: typing.Optional[dt.datetime] = pydantic.Field(default=None)
    """
    The datetime that this object was modified by Merge.
    """

    value: typing.Optional[str] = pydantic.Field(default=None)
    """
    The email address.
    """

    email_address_type: typing.Optional[EmailAddressEmailAddressType] = pydantic.Field(default=None)
    """
    The type of email address.
    
    * `PERSONAL` - PERSONAL
    * `WORK` - WORK
    * `OTHER` - OTHER
    """

    remote_was_deleted: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Indicates whether or not this object has been deleted in the third party platform. Full coverage deletion detection is a premium add-on. Native deletion detection is offered for free with limited coverage. [Learn more](https://docs.merge.dev/integrations/hris/supported-features/).
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
