# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import SyncClientWrapper
from .raw_client import RawHrisClient
from .resources.account_details.client import AccountDetailsClient
from .resources.account_token.client import AccountTokenClient
from .resources.async_passthrough.client import (
    AsyncPassthroughClient as resources_hris_resources_async_passthrough_client_AsyncPassthroughClient,
)
from .resources.audit_trail.client import AuditTrailClient
from .resources.available_actions.client import AvailableActionsClient
from .resources.bank_info.client import BankInfoClient
from .resources.benefits.client import BenefitsClient
from .resources.companies.client import CompaniesClient
from .resources.scopes.client import ScopesClient
from .resources.delete_account.client import DeleteAccountClient
from .resources.dependents.client import DependentsClient
from .resources.employee_payroll_runs.client import EmployeePayrollRunsClient
from .resources.employees.client import EmployeesClient
from .resources.employer_benefits.client import EmployerBenefitsClient
from .resources.employments.client import EmploymentsClient
from .resources.field_mapping.client import FieldMappingClient
from .resources.generate_key.client import GenerateKeyClient
from .resources.groups.client import GroupsClient
from .resources.issues.client import IssuesClient
from .resources.link_token.client import LinkTokenClient
from .resources.linked_accounts.client import LinkedAccountsClient
from .resources.locations.client import LocationsClient
from .resources.passthrough.client import PassthroughClient
from .resources.pay_groups.client import PayGroupsClient
from .resources.payroll_runs.client import PayrollRunsClient
from .resources.regenerate_key.client import RegenerateKeyClient
from .resources.sync_status.client import SyncStatusClient
from .resources.force_resync.client import ForceResyncClient
from .resources.teams.client import TeamsClient
from .resources.time_off.client import TimeOffClient
from .resources.time_off_balances.client import TimeOffBalancesClient
from .resources.timesheet_entries.client import TimesheetEntriesClient
from .resources.webhook_receivers.client import WebhookReceiversClient
from ...core.client_wrapper import AsyncClientWrapper
from .raw_client import AsyncRawHrisClient
from .resources.account_details.client import AsyncAccountDetailsClient
from .resources.account_token.client import AsyncAccountTokenClient
from .resources.async_passthrough.client import AsyncAsyncPassthroughClient
from .resources.audit_trail.client import AsyncAuditTrailClient
from .resources.available_actions.client import AsyncAvailableActionsClient
from .resources.bank_info.client import AsyncBankInfoClient
from .resources.benefits.client import AsyncBenefitsClient
from .resources.companies.client import AsyncCompaniesClient
from .resources.scopes.client import AsyncScopesClient
from .resources.delete_account.client import AsyncDeleteAccountClient
from .resources.dependents.client import AsyncDependentsClient
from .resources.employee_payroll_runs.client import AsyncEmployeePayrollRunsClient
from .resources.employees.client import AsyncEmployeesClient
from .resources.employer_benefits.client import AsyncEmployerBenefitsClient
from .resources.employments.client import AsyncEmploymentsClient
from .resources.field_mapping.client import AsyncFieldMappingClient
from .resources.generate_key.client import AsyncGenerateKeyClient
from .resources.groups.client import AsyncGroupsClient
from .resources.issues.client import AsyncIssuesClient
from .resources.link_token.client import AsyncLinkTokenClient
from .resources.linked_accounts.client import AsyncLinkedAccountsClient
from .resources.locations.client import AsyncLocationsClient
from .resources.passthrough.client import (
    AsyncPassthroughClient as resources_hris_resources_passthrough_client_AsyncPassthroughClient,
)
from .resources.pay_groups.client import AsyncPayGroupsClient
from .resources.payroll_runs.client import AsyncPayrollRunsClient
from .resources.regenerate_key.client import AsyncRegenerateKeyClient
from .resources.sync_status.client import AsyncSyncStatusClient
from .resources.force_resync.client import AsyncForceResyncClient
from .resources.teams.client import AsyncTeamsClient
from .resources.time_off.client import AsyncTimeOffClient
from .resources.time_off_balances.client import AsyncTimeOffBalancesClient
from .resources.timesheet_entries.client import AsyncTimesheetEntriesClient
from .resources.webhook_receivers.client import AsyncWebhookReceiversClient


class HrisClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawHrisClient(client_wrapper=client_wrapper)
        self.account_details = AccountDetailsClient(client_wrapper=client_wrapper)

        self.account_token = AccountTokenClient(client_wrapper=client_wrapper)

        self.async_passthrough = resources_hris_resources_async_passthrough_client_AsyncPassthroughClient(
            client_wrapper=client_wrapper
        )

        self.audit_trail = AuditTrailClient(client_wrapper=client_wrapper)

        self.available_actions = AvailableActionsClient(client_wrapper=client_wrapper)

        self.bank_info = BankInfoClient(client_wrapper=client_wrapper)

        self.benefits = BenefitsClient(client_wrapper=client_wrapper)

        self.companies = CompaniesClient(client_wrapper=client_wrapper)

        self.scopes = ScopesClient(client_wrapper=client_wrapper)

        self.delete_account = DeleteAccountClient(client_wrapper=client_wrapper)

        self.dependents = DependentsClient(client_wrapper=client_wrapper)

        self.employee_payroll_runs = EmployeePayrollRunsClient(client_wrapper=client_wrapper)

        self.employees = EmployeesClient(client_wrapper=client_wrapper)

        self.employer_benefits = EmployerBenefitsClient(client_wrapper=client_wrapper)

        self.employments = EmploymentsClient(client_wrapper=client_wrapper)

        self.field_mapping = FieldMappingClient(client_wrapper=client_wrapper)

        self.generate_key = GenerateKeyClient(client_wrapper=client_wrapper)

        self.groups = GroupsClient(client_wrapper=client_wrapper)

        self.issues = IssuesClient(client_wrapper=client_wrapper)

        self.link_token = LinkTokenClient(client_wrapper=client_wrapper)

        self.linked_accounts = LinkedAccountsClient(client_wrapper=client_wrapper)

        self.locations = LocationsClient(client_wrapper=client_wrapper)

        self.passthrough = PassthroughClient(client_wrapper=client_wrapper)

        self.pay_groups = PayGroupsClient(client_wrapper=client_wrapper)

        self.payroll_runs = PayrollRunsClient(client_wrapper=client_wrapper)

        self.regenerate_key = RegenerateKeyClient(client_wrapper=client_wrapper)

        self.sync_status = SyncStatusClient(client_wrapper=client_wrapper)

        self.force_resync = ForceResyncClient(client_wrapper=client_wrapper)

        self.teams = TeamsClient(client_wrapper=client_wrapper)

        self.time_off = TimeOffClient(client_wrapper=client_wrapper)

        self.time_off_balances = TimeOffBalancesClient(client_wrapper=client_wrapper)

        self.timesheet_entries = TimesheetEntriesClient(client_wrapper=client_wrapper)

        self.webhook_receivers = WebhookReceiversClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawHrisClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawHrisClient
        """
        return self._raw_client


class AsyncHrisClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawHrisClient(client_wrapper=client_wrapper)
        self.account_details = AsyncAccountDetailsClient(client_wrapper=client_wrapper)

        self.account_token = AsyncAccountTokenClient(client_wrapper=client_wrapper)

        self.async_passthrough = AsyncAsyncPassthroughClient(client_wrapper=client_wrapper)

        self.audit_trail = AsyncAuditTrailClient(client_wrapper=client_wrapper)

        self.available_actions = AsyncAvailableActionsClient(client_wrapper=client_wrapper)

        self.bank_info = AsyncBankInfoClient(client_wrapper=client_wrapper)

        self.benefits = AsyncBenefitsClient(client_wrapper=client_wrapper)

        self.companies = AsyncCompaniesClient(client_wrapper=client_wrapper)

        self.scopes = AsyncScopesClient(client_wrapper=client_wrapper)

        self.delete_account = AsyncDeleteAccountClient(client_wrapper=client_wrapper)

        self.dependents = AsyncDependentsClient(client_wrapper=client_wrapper)

        self.employee_payroll_runs = AsyncEmployeePayrollRunsClient(client_wrapper=client_wrapper)

        self.employees = AsyncEmployeesClient(client_wrapper=client_wrapper)

        self.employer_benefits = AsyncEmployerBenefitsClient(client_wrapper=client_wrapper)

        self.employments = AsyncEmploymentsClient(client_wrapper=client_wrapper)

        self.field_mapping = AsyncFieldMappingClient(client_wrapper=client_wrapper)

        self.generate_key = AsyncGenerateKeyClient(client_wrapper=client_wrapper)

        self.groups = AsyncGroupsClient(client_wrapper=client_wrapper)

        self.issues = AsyncIssuesClient(client_wrapper=client_wrapper)

        self.link_token = AsyncLinkTokenClient(client_wrapper=client_wrapper)

        self.linked_accounts = AsyncLinkedAccountsClient(client_wrapper=client_wrapper)

        self.locations = AsyncLocationsClient(client_wrapper=client_wrapper)

        self.passthrough = resources_hris_resources_passthrough_client_AsyncPassthroughClient(
            client_wrapper=client_wrapper
        )

        self.pay_groups = AsyncPayGroupsClient(client_wrapper=client_wrapper)

        self.payroll_runs = AsyncPayrollRunsClient(client_wrapper=client_wrapper)

        self.regenerate_key = AsyncRegenerateKeyClient(client_wrapper=client_wrapper)

        self.sync_status = AsyncSyncStatusClient(client_wrapper=client_wrapper)

        self.force_resync = AsyncForceResyncClient(client_wrapper=client_wrapper)

        self.teams = AsyncTeamsClient(client_wrapper=client_wrapper)

        self.time_off = AsyncTimeOffClient(client_wrapper=client_wrapper)

        self.time_off_balances = AsyncTimeOffBalancesClient(client_wrapper=client_wrapper)

        self.timesheet_entries = AsyncTimesheetEntriesClient(client_wrapper=client_wrapper)

        self.webhook_receivers = AsyncWebhookReceiversClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawHrisClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawHrisClient
        """
        return self._raw_client
